package eclipselink.apachederby.ejb;

import eclipselink.apachederby.entity.Players;
import eclipselink.apachederby.entity.Tournaments;
import eclipselink.apachederby.helper.Helper;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Random;
import javax.ejb.Stateless;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

@Named("bean")
@Stateless
public class SampleBean {

    @PersistenceContext(unitName = "EclipseLink_ManyToMany-ejbPU")
    private EntityManager em;

    public void persistAction() {

        List<Tournaments> tournaments = new ArrayList<>();
        Tournaments t_1 = new Tournaments();
        t_1.setTournament(Helper.TOURNAMENTS[0]);
        t_1.setPlayers(new ArrayList<Players>());
        Tournaments t_2 = new Tournaments();
        t_2.setTournament(Helper.TOURNAMENTS[1]);
        t_2.setPlayers(new ArrayList<Players>());
        Tournaments t_3 = new Tournaments();
        t_3.setTournament(Helper.TOURNAMENTS[2]);
        t_3.setPlayers(new ArrayList<Players>());
        Tournaments t_4 = new Tournaments();
        t_4.setTournament(Helper.TOURNAMENTS[3]);
        t_4.setPlayers(new ArrayList<Players>());
        Tournaments t_5 = new Tournaments();
        t_5.setTournament(Helper.TOURNAMENTS[4]);
        t_5.setPlayers(new ArrayList<Players>());
        Tournaments t_6 = new Tournaments();
        t_6.setTournament(Helper.TOURNAMENTS[5]);
        t_6.setPlayers(new ArrayList<Players>());
        Tournaments t_7 = new Tournaments();
        t_7.setTournament(Helper.TOURNAMENTS[6]);
        t_7.setPlayers(new ArrayList<Players>());
        Tournaments t_8 = new Tournaments();
        t_8.setTournament(Helper.TOURNAMENTS[7]);
        t_8.setPlayers(new ArrayList<Players>());
        Tournaments t_9 = new Tournaments();
        t_9.setTournament(Helper.TOURNAMENTS[8]);
        t_9.setPlayers(new ArrayList<Players>());
        Tournaments t_10 = new Tournaments();
        t_10.setTournament(Helper.TOURNAMENTS[9]);
        t_10.setPlayers(new ArrayList<Players>());
        Tournaments t_11 = new Tournaments();
        t_11.setTournament(Helper.TOURNAMENTS[10]);
        t_11.setPlayers(new ArrayList<Players>());
        Tournaments t_12 = new Tournaments();
        t_12.setTournament(Helper.TOURNAMENTS[11]);
        t_12.setPlayers(new ArrayList<Players>());
        Tournaments t_13 = new Tournaments();
        t_13.setTournament(Helper.TOURNAMENTS[12]);
        t_13.setPlayers(new ArrayList<Players>());
        Tournaments t_14 = new Tournaments();
        t_14.setTournament(Helper.TOURNAMENTS[13]);
        t_14.setPlayers(new ArrayList<Players>());
        Tournaments t_15 = new Tournaments();
        t_15.setTournament(Helper.TOURNAMENTS[14]);
        t_15.setPlayers(new ArrayList<Players>());
        Tournaments t_16 = new Tournaments();
        t_16.setTournament(Helper.TOURNAMENTS[15]);
        t_16.setPlayers(new ArrayList<Players>());
        tournaments.add(t_1);
        tournaments.add(t_2);
        tournaments.add(t_3);
        tournaments.add(t_4);
        tournaments.add(t_5);
        tournaments.add(t_6);
        tournaments.add(t_7);
        tournaments.add(t_8);
        tournaments.add(t_9);
        tournaments.add(t_10);
        tournaments.add(t_11);
        tournaments.add(t_12);
        tournaments.add(t_13);
        tournaments.add(t_14);
        tournaments.add(t_15);
        tournaments.add(t_16);

        Collection<Integer> store_1 = new ArrayList<>();
        Collection<Integer> store_2 = new ArrayList<>();

        int plr_nr = 3 + new Random().nextInt(9);
        for (int i = 0; i <= plr_nr; i++) {

            int data_1 = new Random().nextInt(9);
            if (!store_1.contains(data_1)) {
                Players player = new Players();
                player.setTournaments(new ArrayList<Tournaments>());
                player.setName(Helper.NAMES[i]);
                player.setSurname(Helper.SURNAMES[i]);
                player.setAge(Helper.AGES[i]);
                player.setBirth(Helper.BIRTHS[i]);

                int trn_nr = new Random().nextInt(4);

                store_2.clear();
                for (int j = 0; j <= trn_nr; j++) {
                    int data_2 = new Random().nextInt(16);
                    if (!store_2.contains(data_2)) {
                        Tournaments tournament = tournaments.get(data_2);
                        tournament.getPlayers().add(player);
                        player.getTournaments().add(tournament);
                        store_2.add(data_2);
                    } else {
                        j--;
                    }
                }
                store_1.add(data_1);
                em.persist(player);
            } else {
                i--;
            }
        }
    }

    public List<Players> loadData() {
        List<Players> players = em.createQuery("SELECT e FROM Players e").getResultList();
        return players;
    }

}
